// Code generated by github.com/atombender/go-jsonschema, DO NOT EDIT.

package resolver_config

import "encoding/json"
import "fmt"

// Schema for an Iglu resolver's configuration
type A103 struct {
	// CacheSize corresponds to the JSON schema field "cacheSize".
	CacheSize float64 `json:"cacheSize"`

	// CacheTtl corresponds to the JSON schema field "cacheTtl".
	CacheTtl *int `json:"cacheTtl,omitempty"`

	// Repositories corresponds to the JSON schema field "repositories".
	Repositories []A103RepositoriesElem `json:"repositories"`
}

type A103RepositoriesElem struct {
	// Connection corresponds to the JSON schema field "connection".
	Connection A103RepositoriesElemConnection `json:"connection"`

	// Name corresponds to the JSON schema field "name".
	Name string `json:"name"`

	// Priority corresponds to the JSON schema field "priority".
	Priority float64 `json:"priority"`

	// VendorPrefixes corresponds to the JSON schema field "vendorPrefixes".
	VendorPrefixes []string `json:"vendorPrefixes"`
}

type A103RepositoriesElemConnection map[string]interface{}

// UnmarshalJSON implements json.Unmarshaler.
func (j *A103RepositoriesElem) UnmarshalJSON(b []byte) error {
	var raw map[string]interface{}
	if err := json.Unmarshal(b, &raw); err != nil {
		return err
	}
	if _, ok := raw["connection"]; raw != nil && !ok {
		return fmt.Errorf("field connection in A103RepositoriesElem: required")
	}
	if _, ok := raw["name"]; raw != nil && !ok {
		return fmt.Errorf("field name in A103RepositoriesElem: required")
	}
	if _, ok := raw["priority"]; raw != nil && !ok {
		return fmt.Errorf("field priority in A103RepositoriesElem: required")
	}
	if _, ok := raw["vendorPrefixes"]; raw != nil && !ok {
		return fmt.Errorf("field vendorPrefixes in A103RepositoriesElem: required")
	}
	type Plain A103RepositoriesElem
	var plain Plain
	if err := json.Unmarshal(b, &plain); err != nil {
		return err
	}
	*j = A103RepositoriesElem(plain)
	return nil
}

// UnmarshalJSON implements json.Unmarshaler.
func (j *A103) UnmarshalJSON(b []byte) error {
	var raw map[string]interface{}
	if err := json.Unmarshal(b, &raw); err != nil {
		return err
	}
	if _, ok := raw["cacheSize"]; raw != nil && !ok {
		return fmt.Errorf("field cacheSize in A103: required")
	}
	if _, ok := raw["repositories"]; raw != nil && !ok {
		return fmt.Errorf("field repositories in A103: required")
	}
	type Plain A103
	var plain Plain
	if err := json.Unmarshal(b, &plain); err != nil {
		return err
	}
	*j = A103(plain)
	return nil
}